use `ombutel`;

insert into `ombutel`.`ombu_modules` (`name`, `has_dialplan`, `admin`, `version`, `portal`) values (
	"call_recording", "no", "yes", "1.0", "no");
select last_insert_id() into @module_id;

insert into `ombutel`.`ombu_menu` (`label`, `parent_id`, `module_id`, `sort`)
select
	"menu.call_recording",
	`parent`.`menu_id`
	,@module_id,
	7
from `ombutel`.`ombu_menu` as `parent`
left join `ombutel`.`ombu_menu` as `grandparent` on (`grandparent`.`menu_id` = `parent`.`parent_id`)
where `parent`.`label` = "menu.pbx_settings" and `parent`.`parent_id` is not null;

insert into `ombutel`.`ombu_role_privileges` (`role_id`, `module_id`, `allow_view`, `allow_add`, `allow_edit`, `allow_delete`)
select `role_id`, @module_id, "yes", "yes", "yes", "yes" from `ombutel`.`ombu_roles` where `superadmin` = "yes";

-- move ownership of "recording format" and "recording script" to this module
select `module_id` into @module_id from `ombu_modules` where `name` = 'call_recording';
update `ombu_settings` as `settings`
	left join `ombu_modules` as `modules` on (
		`modules`.`module_id` = `settings`.`module_id`)
	set `settings`.`module_id` = @module_id
	where `settings`.`name` = 'recording_format' and
	`modules`.`name` = 'ombutel';

update `ombu_settings` as `settings`
	left join `ombu_modules` as `modules` on (
		`modules`.`module_id` = `settings`.`module_id`)
	set `settings`.`module_id` = @module_id
	where `settings`.`name` = 'recording_script' and
	 `modules`.`name` = 'ombutel';
