(function () {
	$("a[href='#tab_extension_cdr'] i.reload-tab").remove();
	$("#extension_cdrgeneral [name='from'], #extension_cdrgeneral [name='to']").datetimepicker();
	var table = new pagedtable($("#extension_cdrgeneral .pagedtable"));
	table.callerid = function (value) {
		if (value == "\"\" <>") {
			this.html("-");
		} else {
			this.html(value.replace("\"\"", "").replace("<>", ""));
		}
	};
	var answered = $("#extension_cdrgeneral .pagedtable").data("answered");
	var noanswer = $("#extension_cdrgeneral .pagedtable").data("noanswer");
	var busy = $("#extension_cdrgeneral .pagedtable").data("busy");
	var failed = $("#extension_cdrgeneral .pagedtable").data("failed");
	var make_icon = function (icon, tooltip) { return $("<i>").addClass("glyphicon " + icon).attr("title", tooltip); };
	table.status = function (value) {
		switch (value) {
			case "ANSWERED": { this.append(make_icon("glyphicon-ok-sign", answered)); break; }
			case "NO ANSWER": { this.append(make_icon("glyphicon-remove-sign", noanswer)); break; }
			case "BUSY": { this.append(make_icon("glyphicon-minus-sign", busy)); break; }
			case "FAILED": { this.append(make_icon("glyphicon-exclamation-sign", failed)); break; }
		}
	};
	table.recording = function (value) {
		if (value) {
			if(/http/.test(value)) {
				this.append($("<i>").addClass("glyphicon glyphicon-cloud").data("url", value));
			} else {
				this.append($("<i>").addClass("glyphicon glyphicon-play-circle").data("cdr_id", value));
			}
		}
	};
	var original_onupdate = table.onupdate;
	table.onupdate = function (response) {
		var links = $("#extension_cdrgeneral .form-group-export-spreadsheet a");
		links[0].href = "/?class=extension_cdr&method=csv&id=" + response.cdr_query_id;
		links[1].href = "/?class=extension_cdr&method=ods&id=" + response.cdr_query_id;
		links[2].href = "/?class=extension_cdr&method=json&id=" + response.cdr_query_id;
		links[3].href = "/?class=extension_cdr&method=pdf&id=" + response.cdr_query_id;
		return original_onupdate.apply(this, arguments);
	};
	var search = function() {
		var method = table.data.method;
		table.data.method = "search";
		table.page = 1;
		table.data.cdr_filter_id = $("#extension_cdrgeneral [name='cdr_filter_id']").val();
		table.data.from = $("#extension_cdrgeneral [name='from']").val();
		table.data.to = $("#extension_cdrgeneral [name='to']").val();
		table.data.source = $("#extension_cdrgeneral [name='source']").val();
		table.data.destination = $("#extension_cdrgeneral [name='destination']").val();
		table.page_size = $("#extension_cdrgeneral [name='page_size']").val();
		table.update();
		table.data.method = method;
	};
	$("#tab_extension_cdr .frm-actions button.btn-success").click(search);
	$("#extension_cdrgeneral [name='page_size']").change(function() {
		table.page = 1;
		table.page_size = $("#extension_cdrgeneral [name='page_size']").val();
		table.update();
	});
	$("#extension_cdrgeneral .pagedtable").on("click", "i.glyphicon-play-circle", function() {
		$.ajax({
			type : "POST",
			dataType : "json",
			data : { class: "extension_cdr", method: "play", cdr_id: $(this).data("cdr_id") },
			success : processServerResponse
		});
	});
	$("#extension_cdrgeneral .pagedtable").on("click", "i.glyphicon-cloud", function() {
		var url = $(this).data("url");
		window.open(url, '_blank');
	});
	search();
})();
