(function () {
	var extensionForm = $("#extensions_form");
	var attach_toggle = $("#extensions_form #extensionsvoicemail input#attach");
	var delete_toggle = $("#extensions_form #extensionsvoicemail input#delete");
	var delete_toggle_labels = $("#extensions_form #extensionsvoicemail div.form-group-delete label");
	var new_extension = (extensionForm.find("[name='extension_id']").val() == "");
	var portal_user_is_extension_number = (extensionForm.find("[name='extension']").val() == extensionForm.find("#portal_user").val());
	extensionForm.validate(Validations);
	var getEditExtensionMode = function (id) {
		pbx_request("extensions", "getContent", "edit", id);
	};
	if(extensionForm.find("[name='mode']").val() != 'edit') {
		extensionForm.find("[name='extension']").autocomplete({
				source : extAutoComplete,
				select : function (event, ui) {
					getEditExtensionMode(ui.item.id);
				}
			});
	}
	extensionForm.on("focusout", "[name='extension']", function () {
		if(extensionForm.find("[name='mode']").val() != 'edit') {
			var extension = $(this).val();
			if (extensions[extension] !== undefined) {
				getEditExtensionMode(extensions[extension]);
			}
		}
	}).on("keyup", "[name='extension']", function() {
		var extension = $(this).val();
		if (new_extension) {
			extensionForm.find("#sip-user, #iax-user, #vm_password").val(extension);
		}
		if (portal_user_is_extension_number) {
			extensionForm.find("#portal_user").val(extension);
		}
	}).on("keyup", "[name='name']", function() {
		extensionForm.find("#dev-description").val($(this).val());
	});
	extensionForm.on("keyup", "input[name$='-secret'], input[name='portal_password']", function() {
		show_pass_strength({
			"class" : "extensions",
			"method" : "show_strength",
			"value" : this.value,
			"bar_selector" : "#extensions_form [name='"+this.name+"'] + .password_strength"
		});
	});
	var change_technology = function () {
		var technology = extensionForm.find("[name='technology']:checked").val();
		if (!technology) {
			technology = extensionForm.find("[name='technology']").val();
		}
		var device_form = extensionForm.find(".device-form").show();
		device_form.find(".form-group").hide();
		device_form.find("[name^='"+technology+"-'],[name^='dev-']").closest(".form-group").show();
		if (technology == "none") {
			device_form.hide();
		}

		var device_id = extensionForm.find("[name='device_id']").val();
		if ((typeof device_id != "undefined" && device_id == "new")) { //if new device -> no buttons
			extensionForm.find(
				"button.frmactions-unlink-device, \
				button.frmactions-remove-device").
			hide();
		} else if(technology == "mobile" || technology == "custom") {
			extensionForm.find("button.frmactions-unlink-device").hide();
			extensionForm.find("button.frmactions-remove-device").show();
		} else {
			extensionForm.find("button.frmactions-remove-device").hide();
			extensionForm.find("button.frmactions-unlink-device").show();
		}
		extensionForm.find("input#"+technology+"-secret").trigger("keyup");
	};
	extensionForm.on("change", "[name='device_id']", function () {
		var device_id = $(this).val();
		var extension_id = extensionForm.find("[name='extension_id']").val();
		pbx_request("extensions", "getDevice", "edit", device_id + "|" + extension_id, null, false)
			.done(change_technology);
	});
	extensionForm.on("change", "[name='technology']", change_technology);
	extensionForm.find(
		"button.frmactions-remove-device, \
		button.frmactions-unlink-device"
		).
	on("click", function() {
		var device_id = extensionForm.find("[name='device_id']").val();
		pbx_request("extensions", "unlink", "delete", device_id);
	});
	change_technology();
	$("#extensions_form #extensionsvoicemail input#attach").on('change', function() {
		gray_out(attach_toggle,delete_toggle,delete_toggle_labels);
	});
	gray_out(attach_toggle,delete_toggle,delete_toggle_labels);
})();
