(function() {
	if($("#phonebook_form #mode").val() == "edit") {
		var phonebook = new ombu.datatable(
			$("#phonebookgeneral .pagedtable"),
			"phonebook",
			"get_contacts",
			$("#phonebookgeneral .pagedtable").data("id") != null,
			function() {
				$("#phonebookgeneral .pagedtable tr td:nth-child(8)").each(function() {
					if (this.innerHTML.length > 0) {
						this.innerHTML = '<a href="mailto:' + this.innerHTML + '">' + this.innerHTML + '</a>';
					}
				});
			}
		);
		$("#phonebookgeneral .pagedtable").on("click", "button.btn-warning", function(event) {
			var key = $(event.target).closest("tr").data("key");
			pbx_request("phonebook", "edit_contact", "edit", key);
			return false;
		});
		$("#phonebookgeneral .pagedtable").on("click", "button.btn-danger", function(event) {
			var key = $(event.target).closest("tr").data("key");
			pbx_request("phonebook", "delete_contact", "delete", key);
			return false;
		});
		$("#phonebookgeneral").on("update_phonebook .pagedtable", phonebook.update);
		$("#phonebookgeneral .create-contact").click(function() {
			var key = $("#phonebookgeneral .pagedtable").data("id");
			pbx_request("phonebook", "create_contact", "add", key);
		});
	}

	$("#phonebookgeneral select#brands").on("change", function() {
		if($(this).val().length > 0) {
			$.ajax({
				type : "POST",
				dataType : "json",
				data : {
					class: "phonebook",
					method: "get_phonebooklink",
					brand: $(this).val(),
					phonebook_id: $("#phonebookgeneral #phonebook_id").val()
				},
				success : function(response) {
					if (response && response.link) {
						$("#phonebookgeneral input#phonebook_link").val(response.link);
					} else {
						$("#phonebookgeneral input#phonebook_link").val(phonebook_error);
						show_error();
					}
				},
				error : function() {
					$("#phonebookgeneral input#phonebook_link").val(phonebook_error);
					show_error();
				}
			});
		} else {
			$("#phonebookgeneral input#phonebook_link").val('');
		}
	});

	$("#phonebookgeneral .phonebook_link").on("click", function() {
		var link_field = $("#phonebookgeneral #phonebook_link");
		if(link_field.val().length > 0) {
			link_field.select();
			try {
				var result = document.execCommand("Copy");
				if(result) {
					link_field.attr("data-original-title", phonebook_copied).tooltip("show");
				}
			} catch (err) {
				console.log("unable to copy phonebook link");
			}
			link_field.removeAttr("data-original-title");
		}
	});

	$("#phonebookgeneral button.generate_all").on("click", function() {
		pbx_request("phonebook", "build_all", "build");
	});

	function show_error() {
		// Why not use the standard notification mechanism?
		toastr.warning(
			phonebook_error_msg,
			phonebook_error,
			{
				"positionClass": "toast-top-center"
			}
		);
	}
})();
