(function () {
	var sysMiscClockInterval = 1000;
	var timeField = $("#tztime");

	timeField.timepicker({
		showSecond: true,
		timeFormat: 'hh:mm:ss'
	});

	register_timer("system_misc", "update_clock", updateSysMiscClock, sysMiscClockInterval, true);

	$('input.ntp_activated').bind('change', function() {
		toggle_time_fields($(this));
	});
	toggle_time_fields($('input.ntp_activated'));

	function toggle_time_fields(element) {
		if(element.prop('checked')) {
			element.removeClass('ntp_deactivated');
			element.addClass('ntp_activated');
			$('.sysmisc_time_enabled').addClass('sysmisc_time_disabled');
			$('.sysmisc_time_enabled').removeClass('sysmisc_time_enabled');
			$('.sysmisc_time_disabled').prop('disabled', true);
		} else {
			element.removeClass('ntp_activated');
			element.addClass('ntp_deactivated');
			$('.sysmisc_time_disabled').addClass('sysmisc_time_enabled');
			$('.sysmisc_time_disabled').removeClass('sysmisc_time_disabled');
			$('.sysmisc_time_enabled').prop('disabled', false);
		}
	}

	$('#system_miscgeneral span.system_name_addon').bind('click', function() {
		$.ajax({
			type: "POST",
			dataType: "json",
			data: {
				class: "system_misc",
				method: "save_system_name",
				system_name: $('#system_miscgeneral #system_name').val()
			},
			success: function(response) {
				if(response == true) {
					location.reload();
				} else {
					var data = {state: 'error'};
					data.notification = {text: response};
					processServerResponse(data);
					delegatePBX();
				}
			}
		});
	});

	function updateSysMiscClock(){
		var tab = $('#system_miscgeneral');
		var currentTime = timeField.val();
		var splitTime = currentTime.split(":");
		if(splitTime.length == 2) { // make sure to have seconds
			splitTime[2] = "00";
		}
		var dateObject = new Date();
		dateObject.setHours(splitTime[0]);
		dateObject.setMinutes(splitTime[1]);
		dateObject.setSeconds(splitTime[2]);

		var dataObject2 = new Date(dateObject.valueOf() + sysMiscClockInterval);
		var updatedTime = dataObject2.toTimeString().split(" ")[0];
		timeField.val(updatedTime);
	}
})();
